<?php
switch ($modx->event->name) {

    case 'OnLoadWebDocument':
        // Handle non-ajax requests
        if (!empty($_REQUEST['kk_action'])) {
            if ($initproKassa = $modx->getService('initproKassa')) {
                $initproKassa->handleRequest($_REQUEST['kk_action'], @$_POST);
            }
        }
        break;

    case 'msOnChangeOrderStatus':
        $modx->addPackage('initproKassa', MODX_CORE_PATH . 'components/initprokassa/model/');

        $initproKassaFiscalizer = $modx->getService('initproKassa', 'initproKassaFiscalizer', MODX_CORE_PATH . 'components/initprokassa/model/');

        // заказ имеет статус "оплачен"
        if ($status == 2) {

            $payment = $order->getOne('Payment');
            // заказ оплачен одним из способов оплаты
            if($payment) { // && $payment->get('class')
                $orderId = $order->get('id');
                $existingOrderStatus = $modx->getObject('initproOrderFiscStatus', array('minishop_order_id'=>$orderId));

                // если заказ не уходил на фискализацию
                if ($existingOrderStatus === null){
                    $uniqid = uniqid(strval($checkParams['id']), true);
                    $initproKassaFiscalizer->fiscalize($order, false, $uniqid);
                    $orderStatus = $modx->newObject('initproOrderFiscStatus', array('minishop_order_id' => $orderId, 'fisc_status' => 'pending'));                                                   
                    $orderStatus->save();
                    $modx->exec("UPDATE `modx_initpro_order_fisc_status` SET `fisc_id` = '".$uniqid."', `error` = '' WHERE `modx_initpro_order_fisc_status`.`minishop_order_id` = ". $orderId . " ORDER BY id DESC LIMIT 1");
                }
            }
        }

        if ($status == 4){ // Если заказ отменен, то нужно сделать возврат
            $payment = $order->getOne('Payment');
            if($payment) {
                $orderId = $order->get('id');
                $existingOrderStatus = $modx->getObject('initproOrderFiscStatus', array('minishop_order_id'=>$orderId));
                if ($existingOrderStatus != null){
                    $uniqid = uniqid(strval($checkParams['id']), true);
                    $initproKassaFiscalizer->fiscalize($order, true, $uniqid);
                    $orderStatus = $modx->newObject('initproOrderFiscStatus', array('minishop_order_id' => $orderId, 'fisc_status' => 'pending'));
                    $orderStatus->save();
                    $modx->exec("UPDATE `modx_initpro_order_fisc_status` SET `fisc_id` = '".$uniqid."', `error` = '' WHERE `modx_initpro_order_fisc_status`.`minishop_order_id` = ". $orderId . " ORDER BY id DESC LIMIT 1");
                }
            }
        }
        
        break;

    case 'OnHandleRequest':
        $modx->addPackage('initproKassa', MODX_CORE_PATH . 'components/initprokassa/model/');

        if ($_SERVER['REQUEST_URI'] == '/initpro-kassa-report' && $_SERVER['REQUEST_METHOD'] == 'POST') {
            $secretKey = $modx->getOption('initprokassa_secret');
            if (empty($secretKey)) {
	            error_log('Unable to handle request: module_initpro_kassa_secret_key is not defined');
		        header('HTTP/1.1 500 Internal Server Error');
		        exit();
            }

            $url = $url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://" . $_SERVER['HTTP_HOST'].'/initpro-kassa-report';
	        $data = file_get_contents('php://input');
	        $signature = hash_hmac('md5', $_SERVER['REQUEST_METHOD'] . $url . $data, $secretKey);
            if ($signature != $_SERVER['HTTP_X_HMAC_SIGNATURE']) {
                header('HTTP/1.1 403 Forbidden');
                exit();
            }

            $data = json_decode($data, true);
            foreach (array('external_id', 'state') as $key) {
                if (!array_key_exists($key, $data)) {
                        header('HTTP/1.1 400 Bad Request');
                    header('Content-Type: text/plain');
                    echo $key." is required\n";
                    exit();
                }
            }
            
            $taskID = $data['external_id'];
            $status = $data['state'];
            $errorDescription = $data['state'] === 'error' ? $data['error_description'] : '';

            $modx->exec("UPDATE `modx_initpro_order_fisc_status` SET `fisc_status` = '".$status."', `error` = '".$errorDescription."' WHERE `modx_initpro_order_fisc_status`.`fisc_id` = "."'$taskID'");
        }

        // Обработка ajax запросов к компоненту
        $isAjax = !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && $_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest';
        if (empty($_REQUEST['kk_action']) || !$isAjax) {
            return;
        }
        if ($initproKassa = $modx->getService('initproKassa')) {
            $response = $initproKassa->handleRequest($_REQUEST['kk_action'], @$_POST);
            @session_write_close();
            exit($response);
        }

        break;
}